'''
Created on 16 Mar 2018

@author: Martin Franckie

Module containing physical constants and conversion factors.
'''

import math

pi = math.pi
qe = 1.60217653e-19
h_SI = 6.6260693e-34
h_eV = h_SI/qe
hbar_SI = h_SI/2./pi
hbar_eV = hbar_SI/qe
me = 9.1093826e-31
eps0 = 8.8542e-12
kb_SI = 1.38064852e-23  # J/K
kb_eV = 8.6173303e-5    # eV/K

